JasperLoader (Apache Tomcat 10.1.48 API Documentation)
Description: declaration: package: org.apache.jasper.servlet, class: JasperLoader

# Class JasperLoader

java.lang.Object
java.lang.ClassLoader
java.security.SecureClassLoader
java.net.URLClassLoader
org.apache.jasper.servlet.JasperLoader

All Implemented Interfaces:
  `Closeable, AutoCloseable`

public class JasperLoader extends URLClassLoader
Class loader for loading servlet class files (corresponding to JSP files) and tag handler class files (corresponding to tag files).

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `JasperLoader(URL[] urls, ClassLoader parent, String packageName, PermissionCollection permissionCollection)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final PermissionCollection`
  `getPermissions(CodeSource codeSource)`
  Get the Permissions for a CodeSource.
  `InputStream`
  `getResourceAsStream(String name)`
  Delegate to parent
  `Class<?>`
  `loadClass(String name)`
  Load the class with the specified name.
  `Class<?>`
  `loadClass(String name, boolean resolve)`
  Load the class with the specified name, searching using the following algorithm until it finds and returns the class.

  ### Methods inherited from class URLClassLoader

  `addURL, close, definePackage, findClass, findResource, findResources, getURLs, newInstance, newInstance`

  ### Methods inherited from class SecureClassLoader

  `defineClass, defineClass`

  ### Methods inherited from class ClassLoader

  `clearAssertionStatus, defineClass, defineClass, defineClass, defineClass, definePackage, findClass, findLibrary, findLoadedClass, findResource, findSystemClass, getClassLoadingLock, getDefinedPackage, getDefinedPackages, getName, getPackage, getPackages, getParent, getPlatformClassLoader, getResource, getResources, getSystemClassLoader, getSystemResource, getSystemResourceAsStream, getSystemResources, getUnnamedModule, isRegisteredAsParallelCapable, registerAsParallelCapable, resolveClass, resources, setClassAssertionStatus, setDefaultAssertionStatus, setPackageAssertionStatus, setSigners`

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### JasperLoader

    public JasperLoader(URL[] urls, ClassLoader parent, String packageName, PermissionCollection permissionCollection)

- ## Method Details

  - ### loadClass

    public Class<?> loadClass(String name) throws ClassNotFoundException
    Load the class with the specified name. This method searches for classes in the same manner as `loadClass(String, boolean)` with `false` as the second argument.
    Overrides:
      `loadClass` in class `ClassLoader`
    Parameters:
      `name` - Name of the class to be loaded
    Throws:
      `ClassNotFoundException` - if the class was not found

  - ### loadClass

    public Class<?> loadClass(String name, boolean resolve) throws ClassNotFoundException
    Load the class with the specified name, searching using the following algorithm until it finds and returns the class. If the class cannot be found, returns `ClassNotFoundException`.
    - Call `findLoadedClass(String)` to check if the class has already been loaded. If it has, the same `Class` object is returned.
    - If the `delegate` property is set to `true`, call the `loadClass()` method of the parent class loader, if any.
    - Call `findClass()` to find this class in our locally defined repositories.
    - Call the `loadClass()` method of our parent class loader, if any.
    If the class was found using the above steps, and the `resolve` flag is `true`, this method will then call `resolveClass(Class)` on the resulting Class object.
    Overrides:
      `loadClass` in class `ClassLoader`
    Parameters:
      `name` - Name of the class to be loaded
      `resolve` - If `true` then resolve the class
    Throws:
      `ClassNotFoundException` - if the class was not found

  - ### getResourceAsStream

    public InputStream getResourceAsStream(String name)
    Delegate to parent
    Overrides:
      `getResourceAsStream` in class `URLClassLoader`
    See Also:
      - `ClassLoader.getResourceAsStream(String)`

  - ### getPermissions

    public final PermissionCollection getPermissions(CodeSource codeSource)
    Get the Permissions for a CodeSource. Since this ClassLoader is only used for a JSP page in a web application context, we just return our preset PermissionCollection for the web app context.
    Overrides:
      `getPermissions` in class `URLClassLoader`
    Parameters:
      `codeSource` - Code source where the code was loaded from
    Returns:
      PermissionCollection for CodeSource